export function extend(a = {}, b = {}, ...rest) {
    for(var p in b) a[p] = b[p];
    if(rest.length) a = extend.apply(null, [a, ...rest]);
    return a;
}


function bd(color) {
    return '1px solid ' + color;
}


export let P4CompBtnLine = function P4CompBtnLine({css, color}) {

    css({
        '.btn-ln': {
            'z-index': 1,
            pos: 'relative',
            fl: 'left',
            pad: '8px',
            cur: 'pointer',
            // filter: 'grayscale(1)',
            // '-webkit-filter': 'grayscale(1)',
            op: .7,
            // bdb: css.bd('transparent'),
            bdt: bd('transparent'),
            col: color.grey,
            // ff: css.font.family('ui'),
            // fw: css.font.weight('ui'),
            '&:hover': {
                // filter: 'grayscale(0)',
                // '-webkit-filter': 'grayscale(0)',
                op: 1,
                // bdb: css.bd(color.main2),
                bdt: bd(color.main2),
                '.btn-ln-bar': {
                    w: '100%',
                    op: 1,
                }
            },
            '.btn-ln-bar': {
                'z-index': 2,
                pos: 'absolute',
                left: 0,
                // bottom: '-2px',
                top: '-2px',
                h: '3px',
                w: '1px',
                trs: 'all 0.23s',
                op: 0,
                bg: color.mainLight,
            },
        },
        '.btn-ln-a': {
            // filter: 'grayscale(0)',
            // '-webkit-filter': 'grayscale(0)',
            op: 1,
            // bdb: css.bd(color.main2),
            bdt: bd(color.main2),
            col: color.greyDark,
            '.btn-ln-bar': {
                w: '100%',
                op: 1,
                h: '5px',
                top: '-3px',
                bg: color.grey,
            }
        },
        '.btn-ln-rev.btn-ln': {
            bdt: 0,
            bdb: bd('transparent'),
            '&:hover': {
                bdt: 0,
                bdb: bd(color.main2),
            },
            '.btn-ln-bar': {
                top: 'auto',
                bottom: '-2px',
            },
        },
        '.btn-ln-rev.btn-ln-a': {
            bdt: 0,
            bdb: bd('transparent'),
            '.btn-ln-bar': {
                top: 'auto',
                bottom: '-3px',
            },
        },
    });

    return ({h, props: p}) => {
        let style = {};
        if(p.style) style = extend(style, p.style);
        return h('div', {className: 'btn-ln unselectable' + (p.isActive ? ' btn-ln-a' : '') + (p.isReverse ? ' btn-ln-rev' : ''), style, title: p.title, onClick: p.onClick},
            p.value,
            h('div', {className: 'btn-ln-bar'})
        );
    };
};
