import {P4CompBtnLine} from './btn-line';



function cdn(path) {
    // return `https://192.168.1.10:10000/${path}`;
    return `https://unpkg.com/p4-bot-math@0.0.5/${path}`;
}


function Btn({css, comp, color}) {

    css({
        '.math-btn': {
            d: 'inline-block',
            pos: 'relative',
            pad: '13px',
            cur: 'pointer',
            h: '36px',
            w: '36px',
            '&:hover': {
                span: {
                    bd: '1px solid ' + color.greyLighter,
                    w: '60px',
                    h: '60px',
                    top: '0px',
                    left: '0px',
                },
            },
            '&:active': {
                span: {
                    bd: '2px solid ' + color.mainLight,
                    w: '50px',
                    h: '50px',
                    top: '4px',
                    left: '4px',
                    trs: 'all 0.01s',
                    bdrad: '5px',
                },
            },
            span: {
                d: 'block',
                pos: 'absolute',
                top: '11px',
                left: '11px',
                trs: 'all 0.15s',
                bd: '1px solid #fff',
                bdrad: '3px',
                w: '40px',
                h: '40px',
            }
        }
    });

    let onClick = () => {
        let {props} = comp;
        props.onClick(props.snippet);
    };

    return ({props: p}) => {
        return ['span', {className: 'math-btn', title: p.snippet, onClick},
            ['img', {src: cdn('img/' + p.img)}],
            ['span'],
        ]
    };
}


function BtnSmall({css, comp, color}) {

    css({
        '.math-btn2': {
            d: 'inline-block',
            pos: 'relative',
            pad: '12px',
            cur: 'pointer',
            h: '24px',
            w: '24px',
            '&:hover': {
                span: {
                    bd: '1px solid ' + color.greyLighter,
                    w: '46px',
                    h: '46px',
                    top: '0px',
                    left: '0px',
                },
            },
            '&:active': {
                span: {
                    bd: '2px solid ' + color.mainLight,
                    w: '36px',
                    h: '36px',
                    top: '4px',
                    left: '4px',
                    trs: 'all 0.01s',
                    bdrad: '5px',
                },
            },
            span: {
                d: 'block',
                pos: 'absolute',
                top: '12px',
                left: '13px',
                trs: 'all 0.2s',
                bd: '1px solid #fff',
                bdrad: '3px',
                w: '22px',
                h: '22px',
            }
        }
    });

    let onClick = () => {
        let {props} = comp;
        props.onClick(props.snippet);
    };

    return ({props: p}) => {
        return ['span', {className: 'math-btn2', title: p.snippet, onClick},
            ['img', {src: cdn('img/' + p.img), style: {margin: p.isSmall ? '6px' : 0}}],
            ['span'],
        ]
    };
}


export function P4CompPathTabs({css, comp, set, color}) {

    css({
        '.math': {
            '.math-body': {
                bdt: '1px solid ' + color.greyLightest,
                pad: '20px 0 0',
                mar: '-1px 0 0',
            },
            '.math-line': {
                ta: 'center',
                w: '100%',
            },
            '.math-blocks': {
                d: 'inline-block',
                w: '32px',
                h: '32px',
                fl: 'left',
                mar: '0 15px 0 0',
                cur: 'pointer',
                '&:hover': {
                    span: {
                        bg: color.greyLight,
                    }
                },
                span: {
                    d: 'block',
                    mar: 0,
                    pad: 0,
                    ov: 'hidden',
                    w: '32px',
                    bg: color.greyLighter,
                },
            },
            '.btn-ln': {
                mar: '0 5px 0 0',
                fl: 'left',
            },
        },
    });

    set({
        tab: 'math',
    });

    let onClick = (txt) => {
        let {props} = comp;
        props.onPaste(txt);
    };

    return ({T, state: s}) => {

        let tab = null;

        switch(s.tab) {
            case 'math': {
                tab = ['div', {className: 'math-body'},
                    ['div', {className: 'math-line'},
                        [Btn, {snippet: '\\widetilde{ab}', img: 'widetilde.png', onClick}],
                        [Btn, {snippet: '\\overleftarrow{ba}', img: 'overleftarrow.png', onClick}],
                        [Btn, {snippet: '\\overline{ab}', img: 'overline.png', onClick}],
                        [Btn, {snippet: '\\overbrace{ab}', img: 'overbrace.png', onClick}],
                        [Btn, {snippet: '\\sqrt{ab}', img: 'sqrt.png', onClick}],
                        [Btn, {snippet: 'f\'', img: 'fdash.png', onClick}],
                        [Btn, {snippet: 'x^{k}', img: 'xpk.png', onClick}],
                        [Btn, {snippet: '\\lim_{a \\rightarrow b}', img: 'limit.png', onClick}],
                        [Btn, {snippet: '\\begin{bmatrix}a & b \\\\c & d \\end{bmatrix}', img: 'matrix.png', onClick}],
                        [Btn, {snippet: '\\big(a\\big)', img: 'para.png', onClick}],
                        [Btn, {snippet: '\\int_a^b x', img: 'int.png', onClick}],
                        [Btn, {snippet: '\\sum_a^b x', img: 'sum.png', onClick}],
                        [Btn, {snippet: '\\prod_a^b x', img: 'prod.png', onClick}],
                        [Btn, {snippet: '\\bigcap_a^b x', img: 'bigcap.png', onClick}],
                        [Btn, {snippet: '\\bigvee_a^b x', img: 'bigvee.png', onClick}],
                        [Btn, {snippet: '\\bigotimes', img: 'bigotimes.png', onClick}],
                    ],

                    ['div', {className: 'math-line'},
                        [Btn, {snippet: '\\widehat{ab}', img: 'widehat.png', onClick}],
                        [Btn, {snippet: '\\overrightarrow{ab}', img: 'overrightarrow.png', onClick}],
                        [Btn, {snippet: '\\underline{ab}', img: 'underline.png', onClick}],
                        [Btn, {snippet: '\\underbrace{ab}', img: 'underbrace.png', onClick}],
                        [Btn, {snippet: '\\sqrt[n]{ab}', img: 'sqrtn.png', onClick}],
                        [Btn, {snippet: '\\frac{a}{b}', img: 'frac.png', onClick}],
                        [Btn, {snippet: 'x_{k}', img: 'xuk.png', onClick}],
                        [Btn, {snippet: '\\frac{\\partial^nf}{\\partial x^n}', img: 'partial.png', onClick}],
                        [Btn, {snippet: ' x =\\begin{cases}a & x = 0\\\\b & x > 0\\end{cases} ', img: 'select.png', onClick}],
                        [Btn, {snippet: '\\big\\{a\\big\\}', img: 'curly.png', onClick}],
                        [Btn, {snippet: '\\oint_a^b x', img: 'oint.png', onClick}],
                        [Btn, {snippet: '\\bigsqcup_a^b x', img: 'bigsqcup.png', onClick}],
                        [Btn, {snippet: '\\coprod_a^b x', img: 'coprod.png', onClick}],
                        [Btn, {snippet: '\\bigcup_a^b x', img: 'bigcup.png', onClick}],
                        [Btn, {snippet: '\\bigwedge_a^b x', img: 'bigwedge.png', onClick}],
                        [Btn, {snippet: '\\bigoplus', img: 'bigoplus.png', onClick}],
                    ],
                ];
                break;
            }
            case 'greek': {
                tab = ['div', {className: 'math-body'},
                    ['div', {className: 'math-line', style: {maxWidth:'500px', float:'left', margin:'0 60px 0 0'}},
                        [BtnSmall, {snippet: '\\alpha', img: 'alpha.png', onClick}],
                        [BtnSmall, {snippet: '\\beta', img: 'beta.png', onClick}],
                        [BtnSmall, {snippet: '\\gamma', img: 'gamma.png', onClick}],
                        [BtnSmall, {snippet: '\\delta', img: 'delta.png', onClick}],
                        [BtnSmall, {snippet: '\\epsilon', img: 'epsilon.png', onClick}],
                        [BtnSmall, {snippet: '\\varepsilon', img: 'varepsilon.png', onClick}],
                        [BtnSmall, {snippet: '\\zeta', img: 'zeta.png', onClick}],
                        [BtnSmall, {snippet: '\\eta', img: 'eta.png', onClick}],
                        [BtnSmall, {snippet: '\\theta', img: 'theta.png', onClick}],
                        [BtnSmall, {snippet: '\\vartheta', img: 'vartheta.png', onClick}],
                        [BtnSmall, {snippet: '\\kappa', img: 'kappa.png', onClick}],
                        [BtnSmall, {snippet: '\\lambda', img: 'lambda.png', onClick}],
                        [BtnSmall, {snippet: '\\mu', img: 'mu.png', onClick}],
                        [BtnSmall, {snippet: '\\nu', img: 'nu.png', onClick}],
                        [BtnSmall, {snippet: '\\xi', img: 'xi.png', onClick}],
                        [BtnSmall, {snippet: 'o', img: 'o.png', onClick}],
                        [BtnSmall, {snippet: '\\pi', img: 'pi.png', onClick}],
                        [BtnSmall, {snippet: '\\varpi', img: 'varpi.png', onClick}],
                        [BtnSmall, {snippet: '\\rho', img: 'rho.png', onClick}],
                        [BtnSmall, {snippet: '\\varrho', img: 'varrho.png', onClick}],
                        [BtnSmall, {snippet: '\\sigma', img: 'sigma.png', onClick}],
                        [BtnSmall, {snippet: '\\varsigma', img: 'varsigma.png', onClick}],
                        [BtnSmall, {snippet: '\\tau', img: 'tau.png', onClick}],
                        [BtnSmall, {snippet: '\\upsilon', img: 'upsilon.png', onClick}],
                        [BtnSmall, {snippet: '\\phi', img: 'phi.png', onClick}],
                        [BtnSmall, {snippet: '\\varphi', img: 'varphi.png', onClick}],
                        [BtnSmall, {snippet: '\\chi', img: 'chi.png', onClick}],
                        [BtnSmall, {snippet: '\\psi', img: 'psi.png', onClick}],
                        [BtnSmall, {snippet: '\\omega', img: 'omega.png', onClick}],

                    ],

                    ['div', {className: 'math-line', style: {maxWidth:'330px', float:'left'}},
                        [BtnSmall, {snippet: '\\Gamma', img: 'Gamma.png', onClick}],
                        [BtnSmall, {snippet: '\\Delta', img: 'Delta.png', onClick}],
                        [BtnSmall, {snippet: '\\Theta', img: 'Theta.png', onClick}],
                        [BtnSmall, {snippet: '\\Lambda', img: 'Lambda.png', onClick}],
                        [BtnSmall, {snippet: '\\Xi', img: 'Xi.png', onClick}],
                        [BtnSmall, {snippet: '\\Pi', img: 'Pi.png', onClick}],
                        [BtnSmall, {snippet: '\\Sigma', img: 'Sigma.png', onClick}],
                        [BtnSmall, {snippet: '\\Upsilon', img: 'Upsilon.png', onClick}],
                        [BtnSmall, {snippet: '\\Phi', img: 'Phi.png', onClick}],
                        [BtnSmall, {snippet: '\\Psi', img: 'Psi.png', onClick}],
                        [BtnSmall, {snippet: '\\Omega', img: 'Omega.png', onClick}],
                        [BtnSmall, {snippet: '\\$', img: '$.png', onClick}],
                    ],
                ];
                break;
            }
            case 'relations': {
                tab = ['div', {className: 'math-body'},
                    ['div', {className: 'math-line'},
                        [BtnSmall, {snippet: '\\leq', img: 'leq.png', onClick}],
                        [BtnSmall, {snippet: '\\prec', img: 'prec.png', onClick}],
                        [BtnSmall, {snippet: '\\preceq', img: 'preceq.png', onClick}],
                        [BtnSmall, {snippet: '\\ll', img: 'll.png', onClick}],
                        [BtnSmall, {snippet: '\\subset', img: 'subset.png', onClick}],
                        [BtnSmall, {snippet: '\\subseteq', img: 'subseteq.png', onClick}],
                        [BtnSmall, {snippet: '\\sqsubset', img: 'sqsubset.png', onClick}],
                        [BtnSmall, {snippet: '\\sqsubseteq', img: 'sqsubseteq.png', onClick}],
                        [BtnSmall, {snippet: '\\in', img: 'in.png', onClick}],
                        [BtnSmall, {snippet: '\\vdash', img: 'vdash.png', onClick}],
                        [BtnSmall, {snippet: '>', img: 'gt.png', onClick}],
                        [BtnSmall, {snippet: '\\Join', img: 'Join.png', onClick}],
                        [BtnSmall, {snippet: '\\smile', img: 'smile.png', onClick}],
                        [BtnSmall, {snippet: '\\sim', img: 'sim.png', onClick}],
                        [BtnSmall, {snippet: '\\asymp', img: 'asymp.png', onClick}],
                        [BtnSmall, {snippet: '\\equiv', img: 'equiv.png', onClick}],
                        [BtnSmall, {snippet: '\\mid', img: 'mid.png', onClick}],
                        [BtnSmall, {snippet: '\\neq', img: 'neq.png', onClick}],
                        [BtnSmall, {snippet: '\\perp', img: 'perp.png', onClick}],
                        [BtnSmall, {snippet: ':', img: 'colon.png', onClick}],
                        [BtnSmall, {snippet: '\\rhd', img: 'rhd.png', onClick}],
                        [BtnSmall, {snippet: '\\unrhd', img: 'unrhd.png', onClick}],
                    ],
                    ['div', {className: 'math-line'},
                        [BtnSmall, {snippet: '\\geq', img: 'geq.png', onClick}],
                        [BtnSmall, {snippet: '\\succ', img: 'succ.png', onClick}],
                        [BtnSmall, {snippet: '\\succeq', img: 'succeq.png', onClick}],
                        [BtnSmall, {snippet: '\\gg', img: 'gg.png', onClick}],
                        [BtnSmall, {snippet: '\\supset', img: 'supset.png', onClick}],
                        [BtnSmall, {snippet: '\\supseteq', img: 'supseteq.png', onClick}],
                        [BtnSmall, {snippet: '\\sqsupset', img: 'sqsupset.png', onClick}],
                        [BtnSmall, {snippet: '\\sqsupseteq', img: 'sqsupseteq.png', onClick}],
                        [BtnSmall, {snippet: '\\ni', img: 'ni.png', onClick}],
                        [BtnSmall, {snippet: '\\dashv', img: 'dashv.png', onClick}],
                        [BtnSmall, {snippet: '<', img: 'lt.png', onClick}],
                        [BtnSmall, {snippet: '\\bowtie', img: 'bowtie.png', onClick}],
                        [BtnSmall, {snippet: '\\frown', img: 'frown.png', onClick}],
                        [BtnSmall, {snippet: '\\simeq', img: 'simeq.png', onClick}],
                        [BtnSmall, {snippet: '\\approx', img: 'approx.png', onClick}],
                        [BtnSmall, {snippet: '\\cong', img: 'cong.png', onClick}],
                        [BtnSmall, {snippet: '\\parallel', img: 'parallel.png', onClick}],
                        [BtnSmall, {snippet: '\\doteq', img: 'doteq.png', onClick}],
                        [BtnSmall, {snippet: '\\models', img: 'models.png', onClick}],
                        [BtnSmall, {snippet: '\\propto', img: 'propto.png', onClick}],
                        [BtnSmall, {snippet: '\\lhd', img: 'lhd.png', onClick}],
                        [BtnSmall, {snippet: '\\unlhd', img: 'unlhd.png', onClick}],
                    ],
                ];
                break;
            }
            case 'logic': {
                tab = ['div', {className: 'math-body'},
                    ['div', {className: 'math-line'},
                        [BtnSmall, {snippet: '+', img: 'plus.png', onClick}],
                        [BtnSmall, {snippet: '\\times', img: 'times.png', onClick}],
                        [BtnSmall, {snippet: '\\cap', img: 'cap.png', onClick}],
                        [BtnSmall, {snippet: '\\cup', img: 'cup.png', onClick}],
                        [BtnSmall, {snippet: '\\vee', img: 'vee.png', onClick}],
                        [BtnSmall, {snippet: '\\setminus', img: 'setminus.png', onClick}],
                        [BtnSmall, {snippet: '\\bigtriangleup', img: 'bigtriangleup.png', onClick}],
                        [BtnSmall, {snippet: '\\triangleright', img: 'triangleright.png', onClick}],
                        [BtnSmall, {snippet: '\\rhd', img: 'rhd.png', onClick}],
                        [BtnSmall, {snippet: '\\unrhd', img: 'unrhd.png', onClick}],
                        [BtnSmall, {snippet: '\\oplus', img: 'oplus.png', onClick}],
                        [BtnSmall, {snippet: '\\otimes', img: 'otimes.png', onClick}],
                        [BtnSmall, {snippet: '\\odot', img: 'odot.png', onClick}],
                        [BtnSmall, {snippet: '\\uplus', img: 'uplus.png', onClick}],
                        [BtnSmall, {snippet: '\\ast', img: 'ast.png', onClick}],
                        [BtnSmall, {snippet: '\\circ', img: 'circ.png', onClick}],
                    ],
                    ['div', {className: 'math-line'},
                        [BtnSmall, {snippet: '-', img: 'minus.png', onClick}],
                        [BtnSmall, {snippet: '\\div', img: 'div.png', onClick}],
                        [BtnSmall, {snippet: '\\sqcup', img: 'sqcup.png', onClick}],
                        [BtnSmall, {snippet: '\\sqcap', img: 'sqcap.png', onClick}],
                        [BtnSmall, {snippet: '\\wedge', img: 'wedge.png', onClick}],
                        [BtnSmall, {snippet: '\\wr', img: 'wr.png', onClick}],
                        [BtnSmall, {snippet: '\\bigtriangledown', img: 'bigtriangledown.png', onClick}],
                        [BtnSmall, {snippet: '\\triangleleft', img: 'triangleleft.png', onClick}],
                        [BtnSmall, {snippet: '\\lhd', img: 'lhd.png', onClick}],
                        [BtnSmall, {snippet: '\\unlhd', img: 'unlhd.png', onClick}],
                        [BtnSmall, {snippet: '\\ominus', img: 'ominus.png', onClick}],
                        [BtnSmall, {snippet: '\\oslash', img: 'oslash.png', onClick}],
                        [BtnSmall, {snippet: '\\bigcirc', img: 'bigcirc.png', onClick}],
                        [BtnSmall, {snippet: '\\amalg', img: 'amalg.png', onClick}],
                        [BtnSmall, {snippet: '\\star', img: 'star.png', onClick}],
                        [BtnSmall, {snippet: '\\bullet', img: 'bullet.png', onClick}],
                    ],
                ];
                break;
            }
            case 'symbols': {
                tab = ['div', {className: 'math-body'},
                    ['div', {className: 'math-line'},
                        [BtnSmall, {snippet: '\\ldots', img: 'ldots.png', onClick}],
                        [BtnSmall, {snippet: '\\vdots', img: 'vdots.png', onClick}],
                        [BtnSmall, {snippet: '\\mp', img: 'mp.png', onClick}],
                        [BtnSmall, {snippet: '\\times', img: 'times.png', onClick}],
                        [BtnSmall, {snippet: '/', img: 'slash.png', onClick}],
                        [BtnSmall, {snippet: '|', img: 'or.png', onClick}],
                        [BtnSmall, {snippet: '\\imath', img: 'imath.png', onClick}],
                        [BtnSmall, {snippet: '\\nabla', img: 'nabla.png', onClick}],
                        [BtnSmall, {snippet: '\\top', img: 'top.png', onClick}],
                        [BtnSmall, {snippet: '\\forall', img: 'forall.png', onClick}],
                        [BtnSmall, {snippet: '\\neg', img: 'neg.png', onClick}],
                        [BtnSmall, {snippet: '\\partial', img: 'partial2.png', onClick}],
                        [BtnSmall, {snippet: '\\Re', img: 'Re.png', onClick}],
                        [BtnSmall, {snippet: '\\aleph', img: 'aleph.png', onClick}],
                        [BtnSmall, {snippet: '\\ell', img: 'ell.png', onClick}],
                        [BtnSmall, {snippet: '\\wp', img: 'wp.png', onClick}],
                        [BtnSmall, {snippet: '\\prime', img: 'prime.png', onClick}],
                        [BtnSmall, {snippet: '\\surd', img: 'surd.png', onClick}],
                        [BtnSmall, {snippet: '\\natural', img: 'natural.png', onClick}],
                        [BtnSmall, {snippet: '\\Box', img: 'Box.png', onClick}],
                        [BtnSmall, {snippet: '\\clubsuit', img: 'clubsuit.png', onClick}],
                        [BtnSmall, {snippet: '\\heartsuit', img: 'heartsuit.png', onClick}],
                    ],
                    ['div', {className: 'math-line'},
                        [BtnSmall, {snippet: '\\cdots', img: 'cdots.png', onClick}],
                        [BtnSmall, {snippet: '\\ddots', img: 'ddots.png', onClick}],
                        [BtnSmall, {snippet: '\\pm', img: 'pm.png', onClick}],
                        [BtnSmall, {snippet: '\\div', img: 'div.png', onClick}],
                        [BtnSmall, {snippet: '\\backslash', img: 'backslash.png', onClick}],
                        [BtnSmall, {snippet: '\\|', img: 'parallel.png', onClick}],
                        [BtnSmall, {snippet: '\\jmath', img: 'jmath.png', onClick}],
                        [BtnSmall, {snippet: '\\triangle', img: 'triangle.png', onClick}],
                        [BtnSmall, {snippet: '\\bot', img: 'bot.png', onClick}],
                        [BtnSmall, {snippet: '\\exists', img: 'exists.png', onClick}],
                        [BtnSmall, {snippet: '\\flat', img: 'flat.png', onClick}],
                        [BtnSmall, {snippet: '\\infty', img: 'infty.png', onClick}],
                        [BtnSmall, {snippet: '\\Im', img: 'Im.png', onClick}],
                        [BtnSmall, {snippet: '\\hbar', img: 'hbar.png', onClick}],
                        [BtnSmall, {snippet: '\\mho', img: 'mho.png', onClick}],
                        [BtnSmall, {snippet: '\\emptyset', img: 'emptyset.png', onClick}],
                        [BtnSmall, {snippet: '.', img: 'dot2.png', onClick}],
                        [BtnSmall, {snippet: '\\angle', img: 'angle.png', onClick}],
                        [BtnSmall, {snippet: '\\sharp', img: 'sharp.png', onClick}],
                        [BtnSmall, {snippet: '\\Diamond', img: 'Diamond.png', onClick}],
                        [BtnSmall, {snippet: '\\spadesuit', img: 'spadesuit.png', onClick}],
                        [BtnSmall, {snippet: '\\diamondsuit', img: 'diamondsuit.png', onClick}],
                    ],
                ];
                break;
            }
            case 'arrows': {
                tab = ['div', {className: 'math-body'},
                    ['div', {className: 'math-line'},
                        [BtnSmall, {snippet: '\\leftarrow', img: 'leftarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\Leftarrow', img: 'cLeftarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\leftrightarrow', img: 'leftrightarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\mapsto', img: 'mapsto.png', onClick}],
                        [BtnSmall, {snippet: '\\leftharpoonup', img: 'leftharpoonup.png', onClick}],
                        [BtnSmall, {snippet: '\\rightharpoonup', img: 'rightharpoonup.png', onClick}],
                        [BtnSmall, {snippet: '\\longleftarrow', img: 'longleftarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\Longleftarrow', img: 'cLongleftarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\longleftrightarrow', img: 'longleftrightarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\uparrow', img: 'uparrow.png', onClick}],
                        [BtnSmall, {snippet: '\\downarrow', img: 'downarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\updownarrow', img: 'updownarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\hookleftarrow', img: 'hookleftarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\rightleftharpoons', img: 'rightleftharpoons.png', onClick}],
                        [BtnSmall, {snippet: '\\nearrow', img: 'nearrow.png', onClick}],
                        [BtnSmall, {snippet: '\\searrow', img: 'searrow.png', onClick}],
                    ],
                    ['div', {className: 'math-line'},
                        [BtnSmall, {snippet: '\\rightarrow', img: 'rightarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\Rightarrow', img: 'cRightarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\Leftrightarrow', img: 'cLeftrightarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\longmapsto', img: 'longmapsto.png', onClick}],
                        [BtnSmall, {snippet: '\\leftharpoondown', img: 'leftharpoondown.png', onClick}],
                        [BtnSmall, {snippet: '\\rightharpoondown', img: 'rightharpoondown.png', onClick}],
                        [BtnSmall, {snippet: '\\longrightarrow', img: 'longrightarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\Longrightarrow', img: 'cLongrightarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\Longleftrightarrow', img: 'cLongleftrightarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\Uparrow', img: 'cUparrow.png', onClick}],
                        [BtnSmall, {snippet: '\\Downarrow', img: 'cDownarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\Updownarrow', img: 'cUpdownarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\hookrightarrow', img: 'hookrightarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\leadsto', img: 'leadsto.png', onClick}],
                        [BtnSmall, {snippet: '\\nwarrow', img: 'nwarrow.png', onClick}],
                        [BtnSmall, {snippet: '\\swarrow', img: 'swarrow.png', onClick}],
                    ],
                ];
                break;
            }
        }

        return ['div', {className: 'math unselectable', style: {width:'100%'}},

            ['div', {style: {width:'100%'}},
                ['div', {style: {width:'100px', float:'left'}},
                    ['span', {className: 'math-blocks', title: T('Display math block'), onClick: () => onClick('\n\n$$\n1 + 1\n$$\n\n')},
                        ['span', {style: {margin:'8px 0 0', height:'15px'}}],
                    ],
                    ['span', {className: 'math-blocks', title: T('Inline math'), onClick: () => onClick('$$1 + 1$$')},
                        ['span', {style: {margin:'8px 0 0', height:'3px'}}],
                        ['span', {style: {margin:'3px 0 0', height:'3px'}}],
                        ['span', {style: {margin:'3px 0 0', height:'3px', width:'20px'}}],
                    ],
                ],
                ['div', {style: {margin:'0 0 0 100px'}},
                    [P4CompBtnLine, {value: T('Math'),      isActive: s.tab === 'math',         isReverse: true, onClick: () => set({tab: 'math'})}],
                    [P4CompBtnLine, {value: T('Greek'),     isActive: s.tab === 'greek',        isReverse: true, onClick: () => set({tab: 'greek'})}],
                    [P4CompBtnLine, {value: T('Relations'), isActive: s.tab === 'relations',    isReverse: true, onClick: () => set({tab: 'relations'})}],
                    [P4CompBtnLine, {value: T('Logic'),     isActive: s.tab === 'logic',        isReverse: true, onClick: () => set({tab: 'logic'})}],
                    [P4CompBtnLine, {value: T('Symbols'),   isActive: s.tab === 'symbols',      isReverse: true, onClick: () => set({tab: 'symbols'})}],
                    [P4CompBtnLine, {value: T('Arrows'),    isActive: s.tab === 'arrows',       isReverse: true, onClick: () => set({tab: 'arrows'})}],
                    ['div', {style: {clear:'both'}}],
                ],
            ],

            ['div', {style: {clear:'both'}}],

            tab
        ];
    };
}